unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, ExtCtrls;

type
  THistorie=array of TPoint;
  THistoryList=array of THistorie;
  TfrmMain = class(TForm)
    btnNacist: TButton;
    odMapa: TOpenDialog;
    sbStatus: TStatusBar;
    dgMapa: TDrawGrid;
    gbLegenda: TGroupBox;
    Label1: TLabel;
    Shape1: TShape;
    Label2: TLabel;
    Shape2: TShape;
    Label3: TLabel;
    Shape3: TShape;
    Label4: TLabel;
    Shape4: TShape;
    Label5: TLabel;
    Shape5: TShape;
    Label6: TLabel;
    Shape6: TShape;
    procedure btnNacistClick(Sender: TObject);
    procedure SetStatus(status:string);
    function ParseMap:boolean;
    procedure FindPath;
    procedure ShowMap;
    procedure dgMapaDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FindPos(x,y:integer ; historie:THistorie);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  //teren=(tnNic,tnCesta,tnBezpecnaCesta,tnStart,tnCil,tnTrasa);
var
  frmMain: TfrmMain;
  soubor:TStringList;  
  mapa:array[0..6] of string; //POZOR:pi zadvn souadnic nepouvat [x,y] ale [y,x] !!!
  sirka,vyska:integer;
  found:THistoryList;

implementation

{$R *.dfm}

procedure TfrmMain.SetStatus(status:string);
begin
  sbStatus.Panels[0].Text:=status;
end;

function TfrmMain.ParseMap:boolean;
var i:integer;
    s:textfile;
    line:string;
begin
  try
    AssignFile(s,odMapa.FileName);
    Reset(s);
    i:=0;
    while not eof(s) do begin
      Readln(s,line);
      mapa[i]:=line;
      inc(i);
    end;
    sirka:=length(line);
    vyska:=i;
    CloseFile(s);
  except
    Application.MessageBox('Chyba pi ten souboru !','Chyba',MB_ICONERROR);
    SetStatus('Pipraven');
    result:=false;
    exit;
  end;
  result:=true;
end;

procedure TfrmMain.FindPos(x,y:integer ; historie:THistorie);
var nh:THistorie;
    i:integer;
    p:TPoint;
begin
  p:=Point(x,y);
  SetLength(nh,length(historie)+1);
  for i:=length(historie)-1 downto 0 do begin
    nh[i]:=historie[i];
    if ((historie[i].x=p.x) and (historie[i].y=p.y)) then exit;
  end;
  nh[length(nh)-1]:=p;
  if ((mapa[y,x+1]='S') and (length(nh)>2)) then exit;
  if mapa[y,x+1]='C' then begin
    SetLength(found,length(found)+1);
    found[length(found)-1]:=nh;
    sbStatus.Panels[1].Text:='Nalezeno cest: '+inttostr(length(found));
    Application.ProcessMessages;
    exit;
  end;
  if ((x<sirka-1) and (mapa[y,x+1+1]<>'X')) then FindPos(x+1,y,nh);
  if ((y<vyska-1) and (mapa[y+1,x+1]<>'X')) then FindPos(x,y+1,nh);
  if ((x>0) and (mapa[y,x-1+1]<>'X')) then FindPos(x-1,y,nh);
  if ((y>0) and (mapa[y-1,x+1]<>'X')) then FindPos(x,y-1,nh);
  if (((x<sirka-1) and (y<vyska-1)) and (mapa[y+1,x+1+1]<>'X')) then FindPos(x+1,y+1,nh);
  if (((x>0) and (y>0)) and (mapa[y-1,x-1+1]<>'X')) then FindPos(x-1,y-1,nh);
  if (((x>0) and (y<vyska-1)) and (mapa[y+1,x-1+1]<>'X')) then FindPos(x+1,y-1,nh);
  if (((x<sirka-1) and (y>0)) and (mapa[y-1,x+1+1]<>'X')) then FindPos(x-1,y+1,nh);
end;

procedure TfrmMain.FindPath;
var i,j,sx,sy,nejkr,nejkri:integer;
    h:THistorie;
begin
  sx:=-1;
  sy:=-1;
  SetLength(h,0);
  for i:=1 to vyska-1 do begin
    for j:=0 to sirka do begin
      if mapa[j][i]='S' then begin
        sx:=i-1;
        sy:=j;
        break;
      end;
    end;
    if sx>-1 then break;
  end;
  if sx<0 then begin
    Application.MessageBox('Mapa nem zatek !','Chyba',MB_ICONERROR);
    SetStatus('Pipraven');
    exit;
  end;
  FindPos(sx,sy,h);
  nejkri:=-1;
  nejkr:=65535;
  for i:=0 to length(found) do begin
    if (length(found[i])<nejkr) then begin
      nejkr:=length(found[i]);
      nejkri:=i;
    end;
  end;
  for i:=0 to length(found[nejkri])-1 do begin
    mapa[found[nejkri][i].Y,found[nejkri][i].X+1]:='O';
  end;
end;

procedure TfrmMain.ShowMap;
begin
  dgMapa.RowCount:=vyska;
  dgMapa.ColCount:=sirka+1;
end;

procedure TfrmMain.btnNacistClick(Sender: TObject);
begin
  if not odMapa.Execute then begin
    Application.MessageBox('Zvolte mapu !','Chyba',MB_ICONERROR);
    SetStatus('Pipraven');
    exit;
  end;
  SetStatus('Natm mapu...');
  if ParseMap<>true then
   exit;
  SetStatus('Hledm cestu...');
  FindPath;
  SetStatus('Kreslm mapu...');
  ShowMap;
  SetStatus('Hotovo !');  
end;

procedure TfrmMain.dgMapaDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if sirka<1 then exit;
  if mapa[ARow][ACol]='X' then dgMapa.Canvas.Brush.Color:=clBlack
  else if mapa[ARow][ACol]='.' then dgMapa.Canvas.Brush.Color:=clGreen
  else if mapa[ARow][ACol]=':' then dgMapa.Canvas.Brush.Color:=clYellow
  else if mapa[ARow][ACol]='S' then dgMapa.Canvas.Brush.Color:=clLime
  else if mapa[ARow][ACol]='C' then dgMapa.Canvas.Brush.Color:=clPurple
  else if mapa[ARow][ACol]='O' then dgMapa.Canvas.Brush.Color:=clRed
  else dgMapa.Canvas.Brush.Color:=clWhite;
  dgMapa.Canvas.Rectangle(dgMapa.CellRect(ACol-1,ARow));
end;

end.
